<template>
  <component
    :is="tag"
    class="ui-message rounded border-2 border-solid p-2 [--tw-prose-bullets:rgb(var(--base-rgb)/75%)] [--tw-prose-counters:rgb(var(--base-rgb)/75%)] [--tw-prose-hr:rgb(var(--base-rgb)/50%)] [--tw-prose-quote-borders:rgb(var(--base-rgb)/50%)] [--tw-prose-td-borders:rgb(var(--base-rgb)/25%)] [--tw-prose-th-borders:rgb(var(--base-rgb)/50%)] [&_:first-child]:mt-0 [&_:last-child]:mb-0 [&_:not(:where([class*='ui-'],.not-prose))]:text-current"
    :class="{
      'border-violet-600 bg-violet-50 text-violet-900 [--base-rgb:109_40_217]':
        !info && !success && !warning && !danger && !black && !gray,
      'border-blue-600 bg-blue-50 text-blue-900 [--base-rgb:3_105_161]': info,
      'border-green-700 bg-green-50 text-green-900 [--base-rgb:4_120_87]':
        success,
      'border-yellow-300 bg-yellow-50 text-yellow-900 [--base-rgb:120_53_15]':
        warning,
      'border-red-600 bg-red-50 text-red-800 [--base-rgb:159_18_57]': danger,
      'border-black bg-gray-50 text-black [--base-rgb:23_23_23]': black,
      'border-gray-600 bg-gray-50 text-gray-700 [--base-rgb:64_64_64]': gray,
    }"
  >
    <slot />
  </component>
</template>

<script lang="ts" setup>
defineOptions({
  name: 'UiMessage',
})

defineProps({
  tag: {
    type: String,
    default: 'div',
  },
  info: {
    type: Boolean,
    default: false,
  },
  success: {
    type: Boolean,
    default: false,
  },
  warning: {
    type: Boolean,
    default: false,
  },
  danger: {
    type: Boolean,
    default: false,
  },
  black: {
    type: Boolean,
    default: false,
  },
  gray: {
    type: Boolean,
    default: false,
  },
})
</script>
